// comments indicate manual edits to fix header-parser errors.

{$mode delphi}  //
{$modeswitch objectivec2}
unit Pages;
interface
uses  //
  CTypes,
{$IFDEF NoCocoaAll}
  Foundation,
{$ELSE}
  CocoaAll,
{$ENDIF}
  ScriptingBridge,
  DefinedClassesPages;

(*
  PagesApplicationPtr = ^PagesApplication;
  PagesDocumentPtr = ^PagesDocument;
  PagesWindowPtr = ^PagesWindow;
  PagesRichTextPtr = ^PagesRichText;
  PagesCharacterPtr = ^PagesCharacter;
  PagesParagraphPtr = ^PagesParagraph;
  PagesWordPtr = ^PagesWord;
  PagesIWorkContainerPtr = ^PagesIWorkContainer;
  PagesIWorkItemPtr = ^PagesIWorkItem;
  PagesAudioClipPtr = ^PagesAudioClip;
  PagesShapePtr = ^PagesShape;
  PagesChartPtr = ^PagesChart;
  PagesImagePtr = ^PagesImage;
  PagesGroupPtr = ^PagesGroup;
  PagesLinePtr = ^PagesLine;
  PagesMoviePtr = ^PagesMovie;
  PagesTablePtr = ^PagesTable;
  PagesTextItemPtr = ^PagesTextItem;
  PagesRangePtr = ^PagesRange;
  PagesCellPtr = ^PagesCell;
  PagesRowPtr = ^PagesRow;
  PagesColumnPtr = ^PagesColumn;
  PagesTemplatePtr = ^PagesTemplate;
  PagesSectionPtr = ^PagesSection;
  PagesPagePtr = ^PagesPage;
  PagesPlaceholderTextPtr = ^PagesPlaceholderText;
  PagesGenericMethodsProtocolPtr = ^PagesGenericMethodsProtocol;
*)
const
  PagesSaveOptionsYes = 2036691744;
  PagesSaveOptionsNo = 1852776480;
  PagesSaveOptionsAsk = 1634954016;

type
  PagesSaveOptions = clong;
  PagesSaveOptionsPtr = ^PagesSaveOptions;

const
  PagesPrintingErrorHandlingStandard = 1819767668;
  PagesPrintingErrorHandlingDetailed = 1819763828;

type
  PagesPrintingErrorHandling = clong;
  PagesPrintingErrorHandlingPtr = ^PagesPrintingErrorHandling;

const
  PagesTAVTBottom = 1635148404;
  PagesTAVTCenter = 1633907826;
  PagesTAVTTop = 1635153008;

type
  PagesTAVT = clong;
  PagesTAVTPtr = ^PagesTAVT;

const
  PagesTAHTAutoAlign = 1633777012;
  PagesTAHTCenter = 1633907826;
  PagesTAHTJustify = 1634366324;
  PagesTAHTLeft = 1634494068;
  PagesTAHTRight = 1634888052;

type
  PagesTAHT = clong;
  PagesTAHTPtr = ^PagesTAHT;

const
  PagesNMSDAscending = 1634952046;
  PagesNMSDDescending = 1685283694;

type
  PagesNMSD = clong;
  PagesNMSDPtr = ^PagesNMSD;

const
  PagesNMCTAutomatic = 1717663092;
  PagesNMCTCheckbox = 1717789544;
  PagesNMCTCurrency = 1717794162;
  PagesNMCTDateAndTime = 1717859437;
  PagesNMCTFraction = 1717989985;
  PagesNMCTNumber = 1852662386;
  PagesNMCTPercent = 1718642034;
  PagesNMCTPopUpMenu = 1717792880;
  PagesNMCTScientific = 1718838121;
  PagesNMCTSlider = 1717793644;
  PagesNMCTStepper = 1717793652;
  PagesNMCTText = 1668577396;
  PagesNMCTDuration = 1717859698;
  PagesNMCTRating = 1718772084;
  PagesNMCTNumeralSystem = 1717792371;

type
  PagesNMCT = clong;
  PagesNMCTPtr = ^PagesNMCT;

const
  PagesItemFillOptionsNoFill = 1718185583;
  PagesItemFillOptionsColorFill = 1718182767;
  PagesItemFillOptionsGradientFill = 1718183794;
  PagesItemFillOptionsAdvancedGradientFill = 1718182247;
  PagesItemFillOptionsImageFill = 1718184301;
  PagesItemFillOptionsAdvancedImageFill = 1718182249;

type
  PagesItemFillOptions = clong;
  PagesItemFillOptionsPtr = ^PagesItemFillOptions;

const
  PagesPlaybackRepetitionMethodNone = 1836479086;
  PagesPlaybackRepetitionMethodLoop = 1836477552;
  PagesPlaybackRepetitionMethodLoopBackAndForth = 1836474982;

type
  PagesPlaybackRepetitionMethod = clong;
  PagesPlaybackRepetitionMethodPtr = ^PagesPlaybackRepetitionMethod;

const
  PagesSaveableFileFormatPagesFormat = 1348953702;

type
  PagesSaveableFileFormat = clong;
  PagesSaveableFileFormatPtr = ^PagesSaveableFileFormat;

const
  PagesExportFormatEpub = 1348825205;
  PagesExportFormatUnformattedText = 1349810278;
  PagesExportFormatPDF = 1349543014;
  PagesExportFormatMicrosoftWord = 1350005348;
  PagesExportFormatPages09 = 1347445095;

type
  PagesExportFormat = clong;
  PagesExportFormatPtr = ^PagesExportFormat;

const
  PagesImageQualityGood = 1348948016;
  PagesImageQualityBetter = 1348948017;
  PagesImageQualityBest = 1348948018;

type
  PagesImageQuality = clong;
  PagesImageQualityPtr = ^PagesImageQuality;

type
  PagesGenericMethodsProtocol = objcprotocol external name 'PagesGenericMethods'
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure delete; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure delete_; message 'delete';
  end;

type
  PagesApplication = objcclass external (SBApplication)
  public
    function documents: SBElementArray; message 'documents';
    function windows: SBElementArray; message 'windows';
    function name: NSString; message 'name';
    function frontmost: boolean; message 'frontmost';
    function version: NSString; message 'version';
    function open (x: id): id; message 'open:';
    procedure print_withProperties_printDialog (x: id; withProperties: NSDictionary; printDialog: boolean); message 'print:withProperties:printDialog:';
    procedure quitSaving (saving: PagesSaveOptions); message 'quitSaving:';
    function exists (x: id): boolean; message 'exists:';
  end;

type
  PagesDocument = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    function name: NSString; message 'name';
    function modified: boolean; message 'modified';
    function file_: NSURL; message 'file';
    procedure exportTo_as_withProperties (to_: NSURL; as_: PagesExportFormat; withProperties: NSDictionary); message 'exportTo:as:withProperties:';  //

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesWindow = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    function name: NSString; message 'name';
    function id_: NSInteger; message 'id';
    procedure setIndex(newValue: NSInteger); message 'setIndex:';
    function index: NSInteger; message 'index';
    procedure setBounds(newValue: NSRect); message 'setBounds:';
    function bounds: NSRect; message 'bounds';
    function closeable: boolean; message 'closeable';
    function miniaturizable: boolean; message 'miniaturizable';
    procedure setMiniaturized(newValue: boolean); message 'setMiniaturized:';
    function miniaturized: boolean; message 'miniaturized';
    function resizable: boolean; message 'resizable';
    procedure setVisible(newValue: boolean); message 'setVisible:';
    function visible: boolean; message 'visible';
    function zoomable: boolean; message 'zoomable';
    procedure setZoomed(newValue: boolean); message 'setZoomed:';
    function zoomed: boolean; message 'zoomed';
    function document: PagesDocument; message 'document';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesRichText = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    function characters: SBElementArray; message 'characters';
    function paragraphs: SBElementArray; message 'paragraphs';
    function words: SBElementArray; message 'words';
    procedure setColor(newValue: NSColor); message 'setColor:';
    function color: NSColor; message 'color';
    procedure setFont(newValue: NSString); message 'setFont:';
    function font: NSString; message 'font';
    procedure setSize(newValue: NSInteger); message 'setSize:';
    function size: NSInteger; message 'size';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesCharacter = objcclass external (PagesRichText)
  end;

type
  PagesParagraph = objcclass external (PagesRichText)
  public
    function characters: SBElementArray; message 'characters';
    function words: SBElementArray; message 'words';
  end;

type
  PagesWord = objcclass external (PagesRichText)
  public
    function characters: SBElementArray; message 'characters';
  end;

type
  PagesIWorkContainer = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    function audioClips: SBElementArray; message 'audioClips';
    function charts: SBElementArray; message 'charts';
    function images: SBElementArray; message 'images';
    function iWorkItems: SBElementArray; message 'iWorkItems';
    function groups: SBElementArray; message 'groups';
    function lines: SBElementArray; message 'lines';
    function movies: SBElementArray; message 'movies';
    function shapes: SBElementArray; message 'shapes';
    function tables: SBElementArray; message 'tables';
    function textItems: SBElementArray; message 'textItems';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesIWorkItem = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    procedure setHeight(newValue: NSInteger); message 'setHeight:';
    function height: NSInteger; message 'height';
    procedure setLocked(newValue: boolean); message 'setLocked:';
    function locked: boolean; message 'locked';
    function parent: PagesIWorkContainer; message 'parent';
    procedure setPosition(newValue: NSPoint); message 'setPosition:';
    function position: NSPoint; message 'position';
    procedure setWidth(newValue: NSInteger); message 'setWidth:';
    function width: NSInteger; message 'width';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesAudioClip = objcclass external (PagesIWorkItem)
  public
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setClipVolume(newValue: NSInteger); message 'setClipVolume:';
    function clipVolume: NSInteger; message 'clipVolume';
    procedure setRepetitionMethod(newValue: PagesPlaybackRepetitionMethod); message 'setRepetitionMethod:';
    function repetitionMethod: PagesPlaybackRepetitionMethod; message 'repetitionMethod';
  end;

type
  PagesShape = objcclass external (PagesIWorkItem)
  public
    function backgroundFillType: PagesItemFillOptions; message 'backgroundFillType';
    procedure setObjectText(newValue: PagesRichText); message 'setObjectText:';
    function objectText: PagesRichText; message 'objectText';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
  end;

type
  PagesChart = objcclass external (PagesIWorkItem)
  end;

type
  PagesImage = objcclass external (PagesIWorkItem)
  public
    procedure setObjectDescription(newValue: NSString); message 'setObjectDescription:';
    function objectDescription: NSString; message 'objectDescription';
    function file_: NSURL; message 'file';
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  PagesGroup = objcclass external (PagesIWorkContainer)
  public
    procedure setHeight(newValue: NSInteger); message 'setHeight:';
    function height: NSInteger; message 'height';
    function parent: PagesIWorkContainer; message 'parent';
    procedure setPosition(newValue: NSPoint); message 'setPosition:';
    function position: NSPoint; message 'position';
    procedure setWidth(newValue: NSInteger); message 'setWidth:';
    function width: NSInteger; message 'width';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  PagesLine = objcclass external (PagesIWorkItem)
  public
    procedure setEndPoint(newValue: NSPoint); message 'setEndPoint:';
    function endPoint: NSPoint; message 'endPoint';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
    procedure setStartPoint(newValue: NSPoint); message 'setStartPoint:';
    function startPoint: NSPoint; message 'startPoint';
  end;

type
  PagesMovie = objcclass external (PagesIWorkItem)
  public
    procedure setFileName(newValue: id); message 'setFileName:';
    function fileName: id; message 'fileName';
    procedure setMovieVolume(newValue: NSInteger); message 'setMovieVolume:';
    function movieVolume: NSInteger; message 'movieVolume';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRepetitionMethod(newValue: PagesPlaybackRepetitionMethod); message 'setRepetitionMethod:';
    function repetitionMethod: PagesPlaybackRepetitionMethod; message 'repetitionMethod';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  PagesTable = objcclass external (PagesIWorkItem)
  public
    function cells: SBElementArray; message 'cells';
    function rows: SBElementArray; message 'rows';
    function columns: SBElementArray; message 'columns';
    function ranges: SBElementArray; message 'ranges';
    procedure setName(newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    function cellRange: PagesRange; message 'cellRange';
    procedure setSelectionRange(newValue: PagesRange); message 'setSelectionRange:';
    function selectionRange: PagesRange; message 'selectionRange';
    procedure setRowCount(newValue: NSInteger); message 'setRowCount:';
    function rowCount: NSInteger; message 'rowCount';
    procedure setColumnCount(newValue: NSInteger); message 'setColumnCount:';
    function columnCount: NSInteger; message 'columnCount';
    procedure setHeaderRowCount(newValue: NSInteger); message 'setHeaderRowCount:';
    function headerRowCount: NSInteger; message 'headerRowCount';
    procedure setHeaderColumnCount(newValue: NSInteger); message 'setHeaderColumnCount:';
    function headerColumnCount: NSInteger; message 'headerColumnCount';
    procedure setFooterRowCount(newValue: NSInteger); message 'setFooterRowCount:';
    function footerRowCount: NSInteger; message 'footerRowCount';
    procedure sortBy_direction_inRows (by: PagesColumn; direction: PagesNMSD; inRows: PagesRange); message 'sortBy:direction:inRows:';
  end;

type
  PagesTextItem = objcclass external (PagesIWorkItem)
  public
    function backgroundFillType: PagesItemFillOptions; message 'backgroundFillType';
    procedure setObjectText(newValue: PagesRichText); message 'setObjectText:';
    function objectText: PagesRichText; message 'objectText';
    procedure setOpacity(newValue: NSInteger); message 'setOpacity:';
    function opacity: NSInteger; message 'opacity';
    procedure setReflectionShowing(newValue: boolean); message 'setReflectionShowing:';
    function reflectionShowing: boolean; message 'reflectionShowing';
    procedure setReflectionValue(newValue: NSInteger); message 'setReflectionValue:';
    function reflectionValue: NSInteger; message 'reflectionValue';
    procedure setRotation(newValue: NSInteger); message 'setRotation:';
    function rotation: NSInteger; message 'rotation';
  end;

type
  PagesRange = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    function cells: SBElementArray; message 'cells';
    function columns: SBElementArray; message 'columns';
    function rows: SBElementArray; message 'rows';
    procedure setFontName(newValue: NSString); message 'setFontName:';
    function fontName: NSString; message 'fontName';
    procedure setFontSize(newValue: double); message 'setFontSize:';
    function fontSize: double; message 'fontSize';
    procedure setFormat(newValue: PagesNMCT); message 'setFormat:';
    function format: PagesNMCT; message 'format';
    procedure setAlignment(newValue: PagesTAHT); message 'setAlignment:';
    function alignment: PagesTAHT; message 'alignment';
    function name: NSString; message 'name';
    procedure setTextColor(newValue: NSColor); message 'setTextColor:';
    function textColor: NSColor; message 'textColor';
    procedure setTextWrap(newValue: boolean); message 'setTextWrap:';
    function textWrap: boolean; message 'textWrap';
    procedure setBackgroundColor(newValue: NSColor); message 'setBackgroundColor:';
    function backgroundColor: NSColor; message 'backgroundColor';
    procedure setVerticalAlignment(newValue: PagesTAVT); message 'setVerticalAlignment:';
    function verticalAlignment: PagesTAVT; message 'verticalAlignment';
    procedure clear; message 'clear';
    procedure merge; message 'merge';
    procedure unmerge; message 'unmerge';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesCell = objcclass external (PagesRange)
  public
    function column: PagesColumn; message 'column';
    function row: PagesRow; message 'row';
    procedure setValue(newValue: id); message 'setValue:';
    function value: id; message 'value';
    function formattedValue: NSString; message 'formattedValue';
    function formula: NSString; message 'formula';
  end;

type
  PagesRow = objcclass external (PagesRange)
  public
    function address: NSInteger; message 'address';
    procedure setHeight(newValue: double); message 'setHeight:';
    function height: double; message 'height';
  end;

type
  PagesColumn = objcclass external (PagesRange)
  public
    function address: NSInteger; message 'address';
    procedure setWidth(newValue: double); message 'setWidth:';
    function width: double; message 'width';
  end;


type
  PagesApplication_PagesSuite = objccategory external name 'PagesSuite' (PagesApplication)
    function templates: SBElementArray; message 'templates';
  end;

type
  PagesDocument_PagesSuite = objccategory external name 'PagesSuite' (PagesDocument)
    function audioClips: SBElementArray; message 'audioClips';
    function charts: SBElementArray; message 'charts';
    function groups: SBElementArray; message 'groups';
    function images: SBElementArray; message 'images';
    function iWorkItems: SBElementArray; message 'iWorkItems';
    function lines: SBElementArray; message 'lines';
    function movies: SBElementArray; message 'movies';
    function pages: SBElementArray; message 'pages';
    function sections: SBElementArray; message 'sections';
    function shapes: SBElementArray; message 'shapes';
    function tables: SBElementArray; message 'tables';
    function textItems: SBElementArray; message 'textItems';
    function placeholderTexts: SBElementArray; message 'placeholderTexts';
    function id_: NSString; message 'id';
    function documentTemplate: PagesTemplate; message 'documentTemplate';
    procedure setBodyText(newValue: PagesRichText); message 'setBodyText:';
    function bodyText: PagesRichText; message 'bodyText';
    function documentBody: boolean; message 'documentBody';
    function currentPage: PagesPage; message 'currentPage';
  end;


type
  PagesTemplate = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    function id_: NSString; message 'id';
    function name: NSString; message 'name';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesSection = objcclass external (SBObject, PagesGenericMethodsProtocol)
  public
    function audioClips: SBElementArray; message 'audioClips';
    function charts: SBElementArray; message 'charts';
    function groups: SBElementArray; message 'groups';
    function images: SBElementArray; message 'images';
    function iWorkItems: SBElementArray; message 'iWorkItems';
    function lines: SBElementArray; message 'lines';
    function movies: SBElementArray; message 'movies';
    function pages: SBElementArray; message 'pages';
    function shapes: SBElementArray; message 'shapes';
    function tables: SBElementArray; message 'tables';
    function textItems: SBElementArray; message 'textItems';
    procedure setBodyText(newValue: PagesRichText); message 'setBodyText:';
    function bodyText: PagesRichText; message 'bodyText';

    { Adopted protocols }
    procedure closeSaving_savingIn (saving: PagesSaveOptions; savingIn: NSURL); message 'closeSaving:savingIn:';
    procedure delete; message 'delete';
    procedure delete_; message 'delete';
    procedure duplicateTo_withProperties (to_: SBObject; withProperties: NSDictionary); message 'duplicateTo:withProperties:';
    procedure moveTo (to_: SBObject); message 'moveTo:';
    procedure printWithProperties_printDialog (withProperties: NSDictionary; printDialog: boolean); message 'printWithProperties:printDialog:';
    procedure saveIn_as (in_: NSURL; as_: PagesSaveableFileFormat); message 'saveIn:as:';
  end;

type
  PagesPage = objcclass external (PagesIWorkContainer)
  public
    procedure setBodyText(newValue: PagesRichText); message 'setBodyText:';
    function bodyText: PagesRichText; message 'bodyText';
  end;


type
  PagesRichText_PagesSuite = objccategory external name 'PagesSuite' (PagesRichText)
    function placeholderTexts: SBElementArray; message 'placeholderTexts';
  end;

type
  PagesSuite = objccategory external (PagesParagraph)
    function placeholderTexts: SBElementArray; message 'placeholderTexts';
  end;


type
  PagesPlaceholderText = objcclass external (PagesRichText)
  public
    procedure setTag(newValue: NSString); message 'setTag:';
    function tag: NSString; message 'tag';
  end;

implementation
end.
