program TestNumbers;

{$mode objfpc}{$H+}
{$modeswitch objectivec2}

uses
  SysUtils,
{$IFDEF NoCocoaAll}
  Foundation,
{$ELSE}
  CocoaAll,
{$ENDIF}
  ScriptingBridge,
  Numbers;

var
  NumApp  : NumbersApplication;
  NumDoc  : NumbersDocument;
  NumCell : NumbersCell;
begin
  try
    NumApp := SBApplication.applicationWithBundleIdentifier(NSSTR('com.apple.iWork.Numbers'));
    if not Assigned(NumApp) then
      begin
      WriteLn('Unable to start Numbers.');
      Halt(1);
      end;

     {Output app's name and version}
    WriteLn(NumApp.name.UTF8String, ' ', NumApp.version.UTF8String);

     {Create and add a document}
    NumDoc := class_createInstance(
               NumApp.classForScriptingClass(NSSTR('document')), 0).
                initWithProperties(NSDictionary.dictionaryWithObject_forKey(
                                    NSSTR('My Doc'), NSSTR('name'))).autorelease;
    NumApp.documents.addObject(NumDoc);

     {Change sheet's tab}
    NumbersSheet(NumDoc.sheets.objectAtIndex(0)).setName(NSSTR('My Sheet'));

     {New document will contain one sheet with one table. Get second cell
       of second row in table.}
    NumCell := NumDoc.sheets.objectAtIndex(0).tables.objectAtIndex(0).
                rows.objectAtIndex(1).cells.objectAtIndex(1);

     {Set cell's properties}
    NumCell.setValue(NSNumber.numberWithDouble(1.23));
    NumCell.setFontSize(15);

     {Move app to foreground}
    NumApp.activate;

  except on E:Exception do
    begin
    WriteLn(E.Message);
    Halt(1);
    end;
  end;

end.
