program TestPages;

{$mode objfpc}{$H+}
{$modeswitch objectivec2}

uses
  SysUtils,
{$IFDEF NoCocoaAll}
  Foundation,
{$ELSE}
  CocoaAll,
{$ENDIF}
  ScriptingBridge,
  Pages;

var
  PagesApp : PagesApplication;
  PagesDoc : PagesDocument;
begin
  try
    PagesApp := SBApplication.applicationWithBundleIdentifier(NSSTR('com.apple.iWork.Pages'));
    if not Assigned(PagesApp) then
      begin
      WriteLn('Unable to start Pages.');
      Halt(1);
      end;

     {Output app's name and version}
    WriteLn(PagesApp.name.UTF8String, ' ', PagesApp.version.UTF8String);

     {Create and add a document}
    PagesDoc := class_createInstance(
                 PagesApp.classForScriptingClass(NSSTR('document')), 0).
                  initWithProperties(NSDictionary.dictionaryWithObject_forKey(
                                      NSSTR('My Doc'), NSSTR('name'))).autorelease;
    PagesApp.documents.addObject(PagesDoc);

     {Set document's text}
    PagesDoc.bodyText.setSize(15);
    PagesDoc.bodyText.setTo(NSSTR('Howdy there!'));

     {Move app to foreground}
    PagesApp.activate;

  except on E:Exception do
    begin
    WriteLn(E.Message);
    Halt(1);
    end;
  end;

end.
