program TestScriptEmbed;

{$mode objfpc}{$H+}
{$modeswitch objectivec2}

uses
  SysUtils,
{$IFDEF NoCocoaAll}
  Foundation;
{$ELSE}
  CocoaAll;
{$ENDIF}

function RunScript(out ErrorMsg    : string) : Boolean;
var
  ScriptStr : string;
  ScriptObj : NSAppleScript;
  ErrorInfo : NSDictionary;
  EventDesc : NSAppleEventDescriptor;

begin
  Result := False;
  ErrorMsg := '';

  ScriptStr :=
   'try'#10 +
   '  tell application "Pages"'#10 +
   '    log name & " " & version'#10 +
   '    set pagesDoc to make new document'#10 +
   '    tell pagesDoc'#10 +
   '      set size of body text to 15'#10 +
   '      set body text to "Howdy there!"'#10 +
   '    end tell'#10 +
   '    activate'#10 +
   '  end tell'#10 +
   'on error errMsg number errorNumber'#10 +
   '  return errMsg'#10 +
   'end try';

  ScriptObj := NSAppleScript.alloc.initWithSource(NSSTR(PAnsiChar(ScriptStr)));
  if not Assigned(ScriptObj) then
    begin
    ErrorMsg := 'Unable to load script';
    Exit;
    end;

  try
    EventDesc := ScriptObj.ExecuteAndReturnError(@ErrorInfo);
    if not Assigned(EventDesc) then
      begin
      ErrorMsg := 'Unable to execute script:'#10 +
                  NSString(ErrorInfo.objectForKey(NSAppleScriptErrorMessage)).UTF8String;
      Exit;
      end;
    if (EventDesc.stringValue.UTF8String <> '') and
       (EventDesc.stringValue.UTF8String <> 'true') then
      begin
      ErrorMsg := 'Error executing script:'#10 +
                  EventDesc.stringValue.UTF8String;
      Exit;
      end;

    Result := True;

  finally
    ScriptObj.release;
  end;
end;


var
  ErrorMsg : string;
begin
  if not RunScript(ErrorMsg) then
    begin
    WriteLn(ErrorMsg);
    Halt(1);
    end;
end.
